package eu.clarin.cmdi.mdservice.action;

import java.io.BufferedInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.net.MalformedURLException;
import java.net.URL;

import org.apache.log4j.Logger;

import com.opensymphony.xwork2.ActionSupport;

import eu.clarin.cmdi.mdservice.internal.Admin;
import eu.clarin.cmdi.mdservice.internal.MDTransformer;

/**
 *
 * @author gaba 
 *
 */
public class GenericWorkspaceAction extends ActionSupport 
{

	private static final long serialVersionUID = 1L;
	private static Logger log = Logger.getLogger("GenericWorkspaceAction");
	
	/** 
	 * Properties to be filled by Struts with according request-parameters
	 */	
	private String actionkey;
	private String q;
	private String id;
	private String format;
	private String userMsg;
	
	private String base_path;
	
	public String getQ() {
		return q;
	}

	public void setQ(String q) {
		this.q = q;
	}

	public String getID() {
		return id;
	}

	public void setID(String _id) {
		this.id = _id;
	}
	
	public String getFormat() {
		return format;
	}

	public void setFormat(String format) {
		this.format = format;
	}
	
	public String getActionkey() {
		return actionkey;
	}

	public void setActionkey(String actionKey) {
		actionkey = actionKey;
	}

	/**
	 * primitive identification of the target-proxy
	 * base for finding the right base_url in the props
	 * subclass has to override with its specific proxykey
	 * @return
	 */
	public String getProxyKey() {
		return "";
	}
	
	public String getUserMsg() {
		return userMsg;
	}

	public void setUserMsg(String userMsg) {
		this.userMsg = this.userMsg + "\n" + userMsg;
	}


	private InputStream resultStream;
	private InputStream sourceStream;

	/**
	 * The stream holding the resulting data to be sent back to the user as response
	 * @return
	 */
	public InputStream getResultStream() {
	        return resultStream;
    }
	public void setResultStream(InputStream _resultStream){
		resultStream = _resultStream;
	}
	public void setSourceStream(InputStream _sourceStream){
		sourceStream = _sourceStream;
	}
	
	
	public URL getBaseURL() {
		File file=new File(getPath());
	    URL url=null;
	    try{
		    url=file.toURI().toURL(); 
		    Admin.notifyUser(" JSON TEST: url "  + url);
	    } catch (MalformedURLException e){
	    	Admin.notifyUser("JSON exception has been caught" + e);
	    }
	    
	    return url;
	}
	
	public String getBasePath() {		
		if (base_path == null) {
			base_path = Admin.getConfig().getProperty(getProxyKey() + ".path");
		}
		return base_path;
	}
	//TODO identification of WOrkspaceProfile (user, name, id)
	public String getWorkspaceProfile() {
		return "WorkspaceProfile.xml";
	}
	
	public String getFullFormat() {
		return "xml2json";
	}
	
	public URL getURL() {
		File file=new File(getPath());
	    URL url=null;
	    try{
		    url=file.toURI().toURL();
		    //Admin.notifyUser("url "  + url);
	    } catch (MalformedURLException e){
	    	//Admin.notifyUser("" + e);
	    }
		return url;
	}
	
	
	public String getPath() {
		String targetPath = getBasePath() + getWorkspaceProfile();	   
                      
        return targetPath;
	}

	public InputStream getSourceStream() throws IOException {	
		InputStream stream = new BufferedInputStream( new FileInputStream(getPath()));
		
		return   stream;
	}
	
	public InputStream  getPart(InputStream stream){
		return stream;
	}
	
	public void prepare() throws Exception {		
		
		//Admin.notifyUser(getProxyKey() + ".targetURL: " + getTargetRequest() + " .format:" + getFullFormat());		
		sourceStream = getSourceStream(); 
		if (format.equals("xml")) {			
			resultStream = sourceStream;	
		}else { //JSON
			// set srcFile (for MDTransformer to pass to xsl-scripts) 
			MDTransformer transformer = new MDTransformer();
			transformer.setSrcFile(getURL());
			//InputStream tmp_s =  MDTransformer.getMDTransformer().transformXML(sourceStream, "attr2elements");
			transformer.setParams(MDTransformer.createParamsMap(getFullFormat()));
			InputStream s =  transformer.transformXML(sourceStream);//, getFullFormat());
			resultStream = getPart(s);
		}
			
		log.debug(getProxyKey() + " success:" + (resultStream!=null));
	}

	/**
	 * default Action method
	 */
	public String execute() throws Exception {
		
		prepare();
		if (resultStream == null) {
			return ERROR;	
		} else {
			return SUCCESS;
		}		
	}
	
	

}